Summary: Leading World Wide Web server
Name: apache
Version: 1.3.6
%define perlsrc mod_perl-1.19
%define php3src php-3.0.8
Release: 3
Group: Networking/Daemons
Copyright: Freely distributable and usable
Url: http://www.apache.org
Packager: Hao Li <hli@wag.caltech.edu>
Source: ftp://ftp.apache.org/apache/dist/%{name}_%{version}.tar.gz
Source1: httpd.init
Source2: apache.logrotate
Source3: http://perl.apache.org/dist/%{perlsrc}.tar.gz
Source4: http://www.php.net/distributions/%{php3src}.tar.gz
BuildRoot: /var/tmp/%{name}-root
Requires: perl = 5.005_03

%description
This package is specially configured for Hao Li's personal use. 
You almost always need to rebuild it for your own use.

apache-%{version} + %{perlsrc} + %{php3src} .

Server will run as httpd:httpd rather than nobody:nobody. 
Make sure user and group httpd exist before installing this package.

Documentations:
	apache:		http://www.apache.org/
	mod_perl:	http://perl.apache.org/
	mod_php3:	http://www.php.net/docs.php3


%prep
rm -rf $RPM_BUILD_DIR/{%{perlsrc},%{php3src}}
%setup -q -n apache_%{version} -b 3 -b 4


%build
# Build mod_perl
cd ../%{perlsrc}
perl Makefile.PL \
	APACHE_SRC=../apache_%{version}/src \
	DO_HTTPD=1 \
	USE_APACI=1 \
	USE_DSO=1 \
	PREP_HTTPD=1 \
	EVERYTHING=1
make

# Build mod_php3
cd ../%{php3src}
CPPFLAGS="$RPM_OPT_FLAGS" LDFLAGS=-s \
./configure \
	--with-shared-apache=../apache_%{version} \
	--with-config-file-path=/etc/httpd \
	--enable-track-vars
perl -pi -e 's|^CFLAGS = -g |CFLAGS = |' Makefile
make
make install

# Build Apache
cd ../%{name}_%{version}
OPTIM="$RPM_OPT_FLAGS" ./configure \
	--prefix=/usr \
	--sbindir=/usr/sbin \
	--libexecdir=/usr/lib/apache \
	--includedir=/usr/include/apache \
	--sysconfdir=/etc/httpd \
	--datadir=/home/httpd \
	--logfiledir=/var/log/httpd \
	--localstatedir=/var \
	--runtimedir=/var/run \
	--proxycachedir=/var/cache/httpd \
	--enable-module=all \
	--enable-shared=max \
	--disable-rule=WANTHSREGEX \
	--enable-module=rewrite --enable-shared=rewrite \
	--enable-module=proxy   --enable-shared=proxy \
	--activate-module=src/modules/perl/libperl.a --enable-shared=perl \
	--activate-module=src/modules/php3/libphp3.a --enable-shared=php3
make


%install
rm -rf $RPM_BUILD_ROOT
make install root=$RPM_BUILD_ROOT

# Remove bundled documentations and examples
rm -rf $RPM_BUILD_ROOT/home/httpd/{cgi-bin,htdocs}/*

# Remove outdated configuration files
rm -f $RPM_BUILD_ROOT/etc/httpd/{access,srm}.conf{,.default}

# Change default user:group httpd runs as from nobody:nobody to httpd:httpd
perl -pi -e 's|^User nobody$|User httpd|;s|^Group nobody$|Group httpd|' \
	$RPM_BUILD_ROOT/etc/httpd/{httpd.conf,httpd.conf.default}

# Fix the path of perl
perl -pi -e 's|/usr/local/bin/perl5|/usr/bin/perl|' \
	$RPM_BUILD_ROOT/home/httpd/htdocs/manual/search/manual-index.cgi


# install SYSV init stuff
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m755 %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/httpd

# install log rotation stuff
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 %{SOURCE2} $RPM_BUILD_ROOT/etc/logrotate.d/apache


# Install mod_perl stuff
make -C ../%{perlsrc} install \
	PREFIX=$RPM_BUILD_ROOT/usr \
	INSTALLMAN3DIR=$RPM_BUILD_ROOT/usr/lib/perl5/5.00503/man/man3
perl -pi -e "s|^$RPM_BUILD_ROOT||" $RPM_BUILD_ROOT\
/usr/lib/perl5/site_perl/5.005/i386-linux/auto/mod_perl/.packlist


# Install mod_php3 stuff
install -m644 ../%{php3src}/php3.ini-dist $RPM_BUILD_ROOT/etc/httpd/php3.ini
install -m644 ../%{php3src}/extra/icons/php{3,s}.gif \
	$RPM_BUILD_ROOT/home/httpd/icons


%post
/sbin/chkconfig --add httpd

%preun
if [ $1 = 0 ]; then
   /sbin/chkconfig --del httpd
fi


%files
%defattr(-,root,root)

%dir /etc/httpd
%config /etc/httpd/*
%config /etc/logrotate.d/apache
%config /etc/rc.d/init.d/httpd

/home/httpd

/usr/bin/*
/usr/sbin/*
/usr/man/man*/*
/usr/include/apache
/usr/lib/apache

%dir %attr(-,httpd,httpd) /var/cache/httpd
%dir /var/log/httpd

# mod_perl files
/usr/lib/perl5/5.00503/man/man3/*
/usr/lib/perl5/site_perl/5.005/i386-linux/*


%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Mon May 22 1999 Hao Li <hli@wag.caltech.edu>
- apache-1.3.6-3. Changes:
  mod_php3 upgraded to 3.0.8.
  
* Mon May  3 1999 Hao Li <hli@wag.caltech.edu>
- apache-1.3.6-2. Changes:
  o mod_perl and mod_php3 compiled in.
  o Bundled documentations removed.

* Fri Apr  9 1999 Hao Li <hli@wag.caltech.edu>
- apache-1.3.6-1. Changes:
  o Compiled in rewrite and proxy modules which are disabled by default.
  o Useless stuff under /home/httpd/{cgi-bin,htdocs} are moved away.
  o Server now runs as httpd:httpd rather than nobody:nobody.

* Tue Jan 26 1999 Hao Li <hli@wag.caltech.edu>
- Initial revision: apache-1.3.4-1. The basic spirit of this spec file is to
  keep Apache's default settings as much as possible and to minimize
  customization.
- Difference from RH52 apache-1.3.3-1 spec file:
  1. No patch, no customized config file.
  2. configure argument differences:
	Added:		--sbindir=/usr/sbin
	Changed:	--sysconfdir=/etc/httpd
	Removed:	--serverroot=/etc/httpd
     And the resulting change in installation path is:
     (1) *.conf are now in /etc/httpd rather than /etc/httpd/conf;
     (2) /etc/httpd/{logs,modules} are gone;
     (3) DocumentRoot is now /home/httpd/htdocs rather than /home/httpd/html.
